package frostfsid

import (
	"git.frostfs.info/TrueCloudLab/frostfs-contract/frostfsid/client"
	"github.com/nspcc-dev/neo-go/pkg/util"
)

const (
	SubjectNotFoundErrorMessage = "subject not found"
)

// SubjectProvider interface provides methods to get subject from FrostfsID contract.
type SubjectProvider interface {
	GetSubject(util.Uint160) (*client.Subject, error)
	GetSubjectExtended(util.Uint160) (*client.SubjectExtended, error)
}
