package object

import (
	"fmt"

	objectSDK "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object"
	oid "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object/id"
)

type ECInfo struct {
	ParentID oid.ID
	Index    uint32
	Total    uint32
}

// Info groups object address with its FrostFS
// object info.
type Info struct {
	Address         oid.Address
	Type            objectSDK.Type
	IsLinkingObject bool
	ECInfo          *ECInfo
}

func (v Info) String() string {
	return fmt.Sprintf("address: %s, type: %s, is linking: %t", v.Address, v.Type, v.IsLinkingObject)
}
