package alphabet

import (
	"context"

	"git.frostfs.info/TrueCloudLab/frostfs-node/internal/logs"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/innerring/processors"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/innerring/timers"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/morph/event"
	"go.uber.org/zap"
)

func (ap *Processor) HandleGasEmission(ctx context.Context, ev event.Event) {
	_ = ev.(timers.NewAlphabetEmitTick)
	ap.log.Info(ctx, logs.AlphabetTick, zap.String("type", "alphabet gas emit"))

	// send event to the worker pool

	err := processors.SubmitEvent(ap.pool, ap.metrics, "alphabet_emit_gas", func() bool { return ap.processEmit(ctx) })
	if err != nil {
		// there system can be moved into controlled degradation stage
		ap.log.Warn(ctx, logs.AlphabetAlphabetProcessorWorkerPoolDrained,
			zap.Int("capacity", ap.pool.Cap()))
	}
}
