package blobstor

import (
	"context"

	storagelog "git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/internal/log"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/util/logger"
	oid "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object/id"
)

const (
	deleteOp = "DELETE"
	putOp    = "PUT"
)

func logOp(ctx context.Context, l *logger.Logger, op string, addr oid.Address, typ string, sID []byte) {
	storagelog.Write(ctx, l,
		storagelog.AddressField(addr),
		storagelog.OpField(op),
		storagelog.StorageTypeField(typ),
		storagelog.StorageIDField(sID),
	)
}
