package memstore

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/blobstor/compression"
)

type cfg struct {
	rootPath    string
	readOnly    bool
	compression *compression.Config
}

func defaultConfig() *cfg {
	return &cfg{}
}

type Option func(*cfg)

func WithRootPath(p string) Option {
	return func(c *cfg) {
		c.rootPath = p
	}
}

func WithReadOnly(ro bool) Option {
	return func(c *cfg) {
		c.readOnly = ro
	}
}
