package client

import (
	"crypto/tls"

	"github.com/nspcc-dev/neo-go/pkg/rpcclient"
)

// MTLSConfig represents endpoint mTLS configuration.
type MTLSConfig struct {
	TrustedCAList []string
	KeyFile       string
	CertFile      string
}

func (m *MTLSConfig) parse() (*tls.Config, error) {
	if m == nil {
		return nil, nil
	}

	return rpcclient.TLSClientConfig(m.TrustedCAList, m.CertFile, m.KeyFile)
}
