package container

import (
	"context"

	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/services/util"
	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/container"
)

// Server is an interface of the FrostFS API Container service server.
type Server interface {
	Put(context.Context, *container.PutRequest) (*container.PutResponse, error)
	Get(context.Context, *container.GetRequest) (*container.GetResponse, error)
	Delete(context.Context, *container.DeleteRequest) (*container.DeleteResponse, error)
	List(context.Context, *container.ListRequest) (*container.ListResponse, error)
	ListStream(*container.ListStreamRequest, ListStream) error
}

// ListStream is an interface of FrostFS API v2 compatible search streamer.
type ListStream interface {
	util.ServerStream
	Send(*container.ListStreamResponse) error
}
