// Code generated by protoc-gen-go-frostfs. DO NOT EDIT.

package control

import (
	json "encoding/json"
	fmt "fmt"
	pool "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/pool"
	proto "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto"
	encoding "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto/encoding"
	easyproto "github.com/VictoriaMetrics/easyproto"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
	strconv "strconv"
)

type HealthStatus int32

const (
	HealthStatus_HEALTH_STATUS_UNDEFINED HealthStatus = 0
	HealthStatus_STARTING                HealthStatus = 1
	HealthStatus_READY                   HealthStatus = 2
	HealthStatus_SHUTTING_DOWN           HealthStatus = 3
	HealthStatus_RECONFIGURING           HealthStatus = 4
)

var (
	HealthStatus_name = map[int32]string{
		0: "HEALTH_STATUS_UNDEFINED",
		1: "STARTING",
		2: "READY",
		3: "SHUTTING_DOWN",
		4: "RECONFIGURING",
	}
	HealthStatus_value = map[string]int32{
		"HEALTH_STATUS_UNDEFINED": 0,
		"STARTING":                1,
		"READY":                   2,
		"SHUTTING_DOWN":           3,
		"RECONFIGURING":           4,
	}
)

func (x HealthStatus) String() string {
	if v, ok := HealthStatus_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *HealthStatus) FromString(s string) bool {
	if v, ok := HealthStatus_value[s]; ok {
		*x = HealthStatus(v)
		return true
	}
	return false
}

type Signature struct {
	Key  []byte `json:"key"`
	Sign []byte `json:"signature"`
}

var (
	_ encoding.ProtoMarshaler   = (*Signature)(nil)
	_ encoding.ProtoUnmarshaler = (*Signature)(nil)
	_ json.Marshaler            = (*Signature)(nil)
	_ json.Unmarshaler          = (*Signature)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Signature) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Key)
	size += proto.BytesSize(2, x.Sign)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Signature) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Signature) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Key) != 0 {
		mm.AppendBytes(1, x.Key)
	}
	if len(x.Sign) != 0 {
		mm.AppendBytes(2, x.Sign)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Signature) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Signature")
		}
		switch fc.FieldNum {
		case 1: // Key
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Key")
			}
			x.Key = data
		case 2: // Sign
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Sign")
			}
			x.Sign = data
		}
	}
	return nil
}
func (x *Signature) GetKey() []byte {
	if x != nil {
		return x.Key
	}
	return nil
}
func (x *Signature) SetKey(v []byte) {
	x.Key = v
}
func (x *Signature) GetSign() []byte {
	if x != nil {
		return x.Sign
	}
	return nil
}
func (x *Signature) SetSign(v []byte) {
	x.Sign = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Signature) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Signature) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"key\":"
		out.RawString(prefix)
		if x.Key != nil {
			out.Base64Bytes(x.Key)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"signature\":"
		out.RawString(prefix)
		if x.Sign != nil {
			out.Base64Bytes(x.Sign)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Signature) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Signature) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "key":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Key = f
			}
		case "signature":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Sign = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
