package netmap

import (
	"context"

	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/netmap"
)

// Server is an interface of the FrostFS API Netmap service server.
type Server interface {
	LocalNodeInfo(context.Context, *netmap.LocalNodeInfoRequest) (*netmap.LocalNodeInfoResponse, error)
	NetworkInfo(context.Context, *netmap.NetworkInfoRequest) (*netmap.NetworkInfoResponse, error)
	Snapshot(context.Context, *netmap.SnapshotRequest) (*netmap.SnapshotResponse, error)
}
